#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>

#include "turtle.h"

/*
 * stores the shape type of an icon: circle, square, or triangle
 */
typedef enum {
    CIRCLE,
    SQUARE,
    TRIANGLE
} shapetype_t;

/*
 * stores the data for a single icon: its size and shape
 */
typedef struct {
    size_t size;
    shapetype_t icon_type;
} icon_t;

/*
 * draw a checkerboard grid using the turtle graphics library
 */
void draw_grid(int x, int y, int rows, int columns, int size);

/*
 * find the second minimum of the given array
 */
int second_min(int nums[], int nums_len);

/*
 * return true if the given string is a palindrome
 */
bool is_palindrome(char word[]);

/*
 * finds the longest common character subsequence and saves it to `common`
 */
void same_things(char string1[], char string2[], char common[]);

/*
 * draws an array of icons using the turtle graphics library
 */
void draw_icons(icon_t icons[], int num_icons, int start_x, int start_y);

